<template>
  <q-card :square="!isDesktopPlatform">
    <q-list>
      <q-item>
        <q-item-section side>
          <q-icon
            name="la la-satellite"
            size="md"
            color="dark"
          />
        </q-item-section>
        <q-item-section>
          <q-item-label>
            <translate translate-context="Sentinel-2 is a satellite providing images">
              Sentinel-2 imagery
            </translate>
          </q-item-label>
          <q-item-label
            v-if="latestSatelliteImage"
            caption
            lines="1"
          >
            {{ displayDate(latestSatelliteImage.acquisition_date) }}
          </q-item-label>
        </q-item-section>
      </q-item>
    </q-list>
    <BaseMap
      :center="holdingCampaignCentroid"
      style="height: 300px;"
      :zoom="15"
      :bounds="bounds"
      :overlays-config="mapOverlays"
      activate-satellite-image
      default-satellite-image-mode="ndvi"
    />
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import BaseMap from 'src/components/BaseMap'
import { getDefaultOverlayLayersConfig, getHoldingCampaignPlotsLayer } from 'src/services/map/layers/layer-configs'
import { DateMixin } from 'src/mixins/DateMixin'
import querySatelliteImageLatest from './graphql/querySatelliteImageLatest.graphql'

export default {
  name: 'NewSatelliteImageCard',
  components: {
    BaseMap
  },
  mixins: [
    DateMixin,
    PlatformMixin
  ],
  apollo: {
    latestSatelliteImage: {
      query: querySatelliteImageLatest,
      notifyOnNetworkStatusChange: true,
      update: data => data.satellite_image_processing.length ? data.satellite_image_processing[0].satellite_image : null
    }
  },
  computed: {
    holdingCampaignCentroid () {
      if (this.$store.state.fastplatform.holdingCampaign.centroid) {
        return [this.$store.state.fastplatform.holdingCampaign.centroid.coordinates[1], this.$store.state.fastplatform.holdingCampaign.centroid.coordinates[0]]
      } else {
        return null
      }
    },
    bounds () {
      if (this.$store.state.fastplatform.holdingCampaign.bounds) {
        return this.$store.state.fastplatform.holdingCampaign.bounds
      } else {
        return null
      }
    },
    displayBaseLayers: () => {
      return {
        displayProtectedSiteNatura2000: false,
        displayRegulationZoneNVZ: false,
        displayHydrographySurfaceWater: false,
        displayHydrographyWaterCourse: false,
        displaySoilPublicSamples: false
      }
    },
    mapOverlays () {
      const overlays = getDefaultOverlayLayersConfig(this.displayBaseLayers)
      overlays.push(getHoldingCampaignPlotsLayer(true, { holdingCampaignId: this.$store.state.fastplatform.holdingCampaign.id }))
      return overlays
    }
  }
}
</script>
